"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = void 0;
const tslib_1 = require("tslib");
const getTimestamp_1 = tslib_1.__importDefault(require("../getTimestamp"));
const setImmediate_1 = require("../setImmediate");
const THRESHOLD = 1;
class ConstantTimesliceScheduler {
    start(worker, context, _timeSlice) {
        const timeSlice = _timeSlice || 50;
        let running = true;
        function handler() {
            if (!running) {
                return;
            }
            const timestampStart = (0, getTimestamp_1.default)();
            let emulationTime = 0, delta = 0;
            while ((0, getTimestamp_1.default)() - timestampStart < timeSlice) {
                do {
                    delta = (0, getTimestamp_1.default)() - timestampStart - emulationTime;
                } while (delta < THRESHOLD);
                emulationTime += worker(context, delta);
            }
            delta = (0, getTimestamp_1.default)() - timestampStart - emulationTime;
            if (delta > 0) {
                emulationTime += worker(context, delta);
            }
            if (running) {
                (0, setImmediate_1.setImmediate)(handler);
            }
        }
        (0, setImmediate_1.setImmediate)(handler);
        return { stop: () => (running = false) };
    }
}
exports.default = ConstantTimesliceScheduler;
//# sourceMappingURL=BusyWait.js.map